<script setup lang="ts">
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import type { WorkflowVersionOut } from "@/client/types.gen";
import { onMounted, ref, reactive, computed } from "vue";
import { Modal, Toast } from "bootstrap";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import DeleteModal from "@/components/modals/DeleteModal.vue";
import { useWorkflowStore } from "@/stores/workflows";
import BootstrapToast from "@/components/BootstrapToast.vue";

const workflowRepository = useWorkflowStore();
// Constants
// =============================================================================
const randomIDSuffix = Math.random().toString(16).substring(2, 8);

// Bootstrap Elements
// =============================================================================
let updateIconModal: Modal | null = null;
let successToast: Toast | null = null;

// Form Elements
// =============================================================================
const iconUpdateForm = ref<HTMLFormElement | undefined>(undefined);
const iconElement = ref<HTMLImageElement | undefined>(undefined);
const iconInputElement = ref<HTMLInputElement | undefined>(undefined);

// Props
// =============================================================================
const props = defineProps<{
  modalId: string;
  version: WorkflowVersionOut;
  workflowName?: string;
}>();

// Reactive State
// =============================================================================
const iconUpdate = reactive<{
  icon: Blob | null;
}>({
  icon: null,
});

const formState = reactive<{
  loading: boolean;
  validated: boolean;
  uploadIcon: boolean;
}>({
  loading: false,
  validated: false,
  uploadIcon: true,
});

// Computed Properties
// =============================================================================
const showIcon = computed<boolean>(
  () => props.version.icon_url != undefined || iconUpdate.icon != undefined,
);

// Functions
// =============================================================================
function resetForm() {
  iconElement.value!.src = props.version.icon_url ?? "";
  if (iconInputElement.value != undefined) {
    iconInputElement.value.value = "";
  }
}

function modalClosed() {
  formState.validated = false;
  resetForm();
}

function iconChanged() {
  iconUpdate.icon = iconInputElement.value?.files?.[0].slice() ?? null;
  if (iconUpdate.icon != null) {
    iconElement.value!.src = URL.createObjectURL(iconUpdate.icon.slice());
  } else {
    iconElement.value!.src = props.version.icon_url ?? "";
  }
}

function updateIcon() {
  formState.validated = true;
  if (iconUpdateForm.value?.checkValidity() && iconUpdate.icon != null) {
    formState.loading = true;
    workflowRepository
      .updateVersionIcon(
        props.version.workflow_id,
        props.version.workflow_version_id,
        {
          icon: iconUpdate.icon,
        },
      )
      .then(() => {
        formState.uploadIcon = true;
        successToast?.show();
        updateIconModal?.hide();
      })
      .catch((error) => {
        console.error(error);
      })
      .finally(() => {
        formState.loading = false;
      });
  }
}

function deleteIcon() {
  formState.loading = true;
  workflowRepository
    .deleteVersionIcon(
      props.version.workflow_id,
      props.version.workflow_version_id,
    )
    .then(() => {
      formState.uploadIcon = false;
      successToast?.show();
      updateIconModal?.hide();
    })
    .catch((error) => {
      console.error(error);
    })
    .finally(() => {
      formState.loading = false;
    });
}

// Lifecycle Events
// =============================================================================
onMounted(() => {
  updateIconModal = new Modal("#" + props.modalId);
  successToast = new Toast("#successToast-" + randomIDSuffix);
});
</script>

<template>
  <DeleteModal
    v-if="props.version.icon_url"
    :modal-id="'delete-icon-modal' + randomIDSuffix"
    :object-name-delete="'icon for workflow ' + props.workflowName"
    :back-modal-id="modalId"
    @confirm-delete="deleteIcon()"
  />
  <bootstrap-toast :toast-id="'successToast-' + randomIDSuffix">
    <template v-if="formState.uploadIcon">Successfully uploaded icon</template>
    <template v-else>Successfully deleted icon</template>
  </bootstrap-toast>
  <bootstrap-modal
    :modal-id="modalId"
    :static-backdrop="true"
    modal-label="Update Workflow Version Icon Modal"
    v-on="{ 'hidden.bs.modal': modalClosed }"
  >
    <template #header>
      Update Icon Workflow
      <span class="fw-bold"
        >{{ props.workflowName }}@{{ props.version.version }}</span
      >
    </template>
    <template v-if="props.version.icon_url" #extra-button>
      <button
        class="btn delete-icon"
        data-bs-toggle="modal"
        :data-bs-target="'#delete-icon-modal' + randomIDSuffix"
      >
        <font-awesome-icon icon="fa-solid fa-trash" />
      </button>
    </template>
    <template #body>
      <form
        id="iconUpdateForm"
        ref="iconUpdateForm"
        :class="{ 'was-validated': formState.validated }"
      >
        <div class="row">
          <div class="col-10">
            <label for="workflowIconInput" class="form-label">New Icon</label>
            <input
              id="workflowIconInput"
              ref="iconInputElement"
              type="file"
              accept="image/*"
              class="form-control"
              aria-describedby="iconHelp"
              required
              @change="iconChanged"
            />
          </div>
          <div class="col-2">
            <img
              ref="iconElement"
              :src="props.version.icon_url ?? undefined"
              :hidden="!showIcon"
            />
          </div>
        </div>
      </form>
    </template>
    <template #footer>
      <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">
        Close
      </button>
      <button
        type="submit"
        form="iconUpdateForm"
        class="btn btn-primary"
        :disabled="formState.loading"
        @click.prevent="updateIcon"
      >
        <span
          v-if="formState.loading"
          class="spinner-border spinner-border-sm"
          role="status"
          aria-hidden="true"
        ></span>
        Save
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped>
img {
  max-height: 64px;
  max-width: 64px;
}

.delete-icon {
  color: var(--bs-secondary) !important;
}

.delete-icon:hover {
  color: var(--bs-danger) !important;
}
</style>
